package at.jku.ssw.psw2.ue02.demo;

import java.lang.reflect.InvocationTargetException;

import inout.Out;

public class AnnotationDemo {

	public static void main(String[] args) throws InstantiationException, IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchMethodException, SecurityException {

		Class<Person> pCl = Person.class; 
		
		if (pCl.isAnnotationPresent(Parse.class)) {
			
			Parse pAnn = pCl.getAnnotation(Parse.class); 
			
			Class<? extends Parser<?>>  parserType = pAnn.value(); 
			
			Parser<?> parser = parserType.getConstructor().newInstance(); 
			Object o = parser.parse("Hans Male"); 
			
			Out.println(o.toString()); 
		}
	}

}
