package at.jku.ssw.psw2.ue02.demo;

import static inout.Out.println;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method; 

public class InvokeDemo {
	
	public static void main(String[] args) throws Exception {
//		Person p = new Person("Anna", Sex.Female);
		
		Class<Person> cl = Person.class; 
		
		Constructor<Person> pConst = cl.getConstructor(String.class, Sex.class);
		Person p = pConst.newInstance("Anna", Sex.Female); 
		
		Method getNameM = cl.getMethod("getName"); 
		String name = (String)getNameM.invoke(p); 
		println(name); 
		
		Method setNameM = cl.getMethod("setName", String.class); 
		setNameM.invoke(p, "Berta"); 
		println(getNameM.invoke(p)); 
		
		Field nameF = cl.getDeclaredField("name"); 
		nameF.setAccessible(true);
		nameF.set(p, "Gusti");
		println(getNameM.invoke(p)); 

	}

}
