package at.jku.ssw.psw2.ue02.demo;

public class Box<T extends Comparable<T>> {
	
	private T val;

	public Box(T val) {
		super();
		this.val = val;
	}

	public T getVal() {
		return val;
	}

	public void setVal(T val) {
		if (this.val.compareTo(val) > 0) {
			this.val = val;
		}
	}

	@Override
	public String toString() {
		return "Box[" + val + "]";
	} 


}
