package at.jku.ssw.psw2.ue02.demo;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.TypeVariable;

import inout.Out;

public class GenericDemo {

	public static void main(String[] args) throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException, NoSuchFieldException {
		
		Box<String> iBox = new Box<>("A"); 
		
		Class<?> cl = iBox.getClass(); 
		
		Class<Box> bCl = Box.class; 
		TypeVariable<Class<Box>> tv = bCl.getTypeParameters()[0]; 
		
		Field f = cl.getDeclaredField("val"); 
		
//		Method m = cl.getDeclaredMethod("setVal", String.class); 
//		Method m = cl.getDeclaredMethod("setVal", Object.class); 
		Method m = cl.getDeclaredMethod("setVal", Comparable.class); 
		
		m.invoke(iBox, "B"); 
		
		Out.println(iBox.getVal()); 
	}

}
