package at.jku.ssw.psw2.ue02.demo;

import inout.Out;

public class ReflectionDemo {

	public static void main(String[] args) {
		
		Person p = new Person("Hans", Sex.Male); 
		
		Class<?> cl = p.getClass(); 
		Class<Person> clp = Person.class; 
		
//		PrettyPrinter.print(cl);

		Class<? extends Person> pCl = cl.asSubclass(Person.class);
//		cl = Class.forName("at.jku.ssw.psw2.ue02.demo.Person");
		
		Class<Person> clazz = Person.class; 
		
		Out.println(clazz.getName()); 
		Out.println(clazz.getCanonicalName()); 
		Out.println(clazz.getSimpleName()); 

		Out.println(int.class.getName()); 
		Out.println(int.class.getCanonicalName()); 
		Out.println(int.class.getSimpleName()); 
		
		Person ap = new Person("Hans", Sex.Male) {
		}; 
		
		Out.println(ap.getClass().getName()); 
		Out.println(ap.getClass().getCanonicalName()); 
		Out.println(ap.getClass().getSimpleName()); 
		
		Person[] pa = new Person[1]; 
	
		Out.println(pa.getClass().getName()); 
		Out.println(pa.getClass().getCanonicalName()); 
		Out.println(pa.getClass().getSimpleName()); 
	}

}
